## ros-one-imu-filter-madgwick 1.2.6-4jammy.20251023.0850

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)
project(imu_filter_madgwick)

find_package(catkin REQUIRED COMPONENTS
  dynamic_reconfigure
  geometry_msgs
  message_filters
  nodelet
  pluginlib
  roscpp
  sensor_msgs
  tf2
  tf2_geometry_msgs
  tf2_ros
)

find_package(Boost REQUIRED COMPONENTS system thread)

# Generate dynamic parameters
generate_dynamic_reconfigure_options(cfg/ImuFilterMadgwick.cfg)

catkin_package(
  DEPENDS Boost
  CATKIN_DEPENDS
    dynamic_reconfigure
    geometry_msgs
    message_filters
    nodelet
    pluginlib
    roscpp
    sensor_msgs
    tf2_geometry_msgs
    tf2_ros
  INCLUDE_DIRS include
  LIBRARIES imu_filter imu_filter_nodelet
)

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
)


# create imu_filter library
add_library (imu_filter src/imu_filter.cpp  src/imu_filter_ros.cpp src/stateless_orientation.cpp)
add_dependencies(imu_filter ${PROJECT_NAME}_gencfg)
target_link_libraries(imu_filter ${catkin_LIBRARIES} ${Boost_LIBRARIES})

# create imu_filter_nodelet library
add_library (imu_filter_nodelet src/imu_filter_nodelet.cpp)
add_dependencies(imu_filter_nodelet ${PROJECT_NAME}_gencfg)
target_link_libraries(imu_filter_nodelet imu_filter ${catkin_LIBRARIES} ${Boost_LIBRARIES})

# create imu_filter_node executable
add_executable(imu_filter_node src/imu_filter_node.cpp)
add_dependencies(imu_filter_node ${PROJECT_NAME}_gencfg)
target_link_libraries(imu_filter_node imu_filter ${catkin_LIBRARIES} ${Boost_LIBRARIES})


install(TARGETS imu_filter_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(TARGETS imu_filter imu_filter_nodelet
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
   FILES_MATCHING PATTERN "*.h"
)

install(FILES imu_filter_nodelet.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)



if(CATKIN_ENABLE_TESTING)
  catkin_add_gtest(${PROJECT_NAME}-madgwick_test
    test/stateless_orientation_test.cpp
    test/madgwick_test.cpp
  )
  target_link_libraries(${PROJECT_NAME}-madgwick_test
    imu_filter
    ${catkin_LIBRARIES}
  )
endif()

=== debian/changelog ===
ros-one-imu-filter-madgwick (1.2.6-4jammy.20251023.0850) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Günther <martin.guenther1980@gmail.com>  Thu, 23 Oct 2025 08:50:18 +0000

ros-one-imu-filter-madgwick (1.2.6-0jammy) jammy; urgency=high

  * Merge pull request #192 <https://github.com/CCNYRoboticsLab/imu_tools/issues/192> from enwaytech/av/remove_launchers
    Increase max stddev, add pose visualization, fix error messages
  * add timeout to lookupTransform
    Otherwise there are a lot of warnings of lookup would require extrapolation into the future
  * publish orientation as Pose to vis on rviz
  * show correct topics even if remapped
  * increase max covariance
  * Contributors: Adi Vardi, Martin Günther

 -- Martin Günther <martin.guenther1980@gmail.com>  Fri, 12 Jan 2024 00:00:00 -0000

ros-one-imu-filter-madgwick (1.2.5-0jammy) jammy; urgency=high

  * Added ability to reset IMU filters when ROS time jumps back. (#165 <https://github.com/CCNYRoboticsLab/imu_tools/issues/165>)
  * Contributors: Martin Pecka

 -- Martin Günther <martin.guenther1980@gmail.com>  Fri, 19 Aug 2022 00:00:00 -0000

ros-one-imu-filter-madgwick (1.2.4-0jammy) jammy; urgency=high

  * Reformat everything using clang-format
  * Fix package dependencies
  * Fix trailing whitespace
  * Fix typo
  * Add declination and yaw offset. (#121 <https://github.com/CCNYRoboticsLab/imu_tools/issues/121>)
    Fixes #120 <https://github.com/CCNYRoboticsLab/imu_tools/issues/120>.
  * Add license files
    The "COPYING" file incorrectly had the text of the LGPL, but the
    original Madgwick filter [1], [2] is GPL licensed. The source code
    headers correctly have the GPLv3 license text.
    [1]: https://x-io.co.uk/open-source-imu-and-ahrs-algorithms/
    [2]: https://github.com/xioTechnologies/Fusion
  * Contributors: Martin Günther, tgreier

 -- Martin Günther <martin.guenther1980@gmail.com>  Tue, 12 Apr 2022 00:00:00 -0000

ros-one-imu-filter-madgwick (1.2.3-0jammy) jammy; urgency=high

  * Fix "non standard content" warning in imu_tools metapackage
    Fixes #135 <https://github.com/ccny-ros-pkg/imu_tools/issues/135>.
  * Add example launch file for imu_filter_madgwick (#132 <https://github.com/ccny-ros-pkg/imu_tools/issues/132>)
  * Update maintainers in package.xml
  * Fix warnings: reordering and unused vars
  * Set cmake_policy CMP0048 to fix warning
  * Contributors: Martin Günther, pietrocolombo

 -- Martin Günther <martin.guenther1980@gmail.com>  Fri, 09 Apr 2021 00:00:00 -0000

ros-one-imu-filter-madgwick (1.2.2-0jammy) jammy; urgency=high

  * Drop the signals component of Boost (#103 <https://github.com/ccny-ros-pkg/imu_tools/issues/103>)
  * Add the option to remove the gravity vector (#101 <https://github.com/ccny-ros-pkg/imu_tools/issues/101>)
  * fix install path & boost linkage issues
  * Contributors: Alexis Paques, Martin Günther, Mike Purvis, Sean Yen

 -- Martin Günther <martin.guenther1980@gmail.com>  Mon, 25 May 2020 00:00:00 -0000

ros-one-imu-filter-madgwick (1.2.1-0jammy) jammy; urgency=high

  * Skip messages and warn if computeOrientation fails
  * Contributors: Martin Günther

 -- Martin Günther <martin.guenther1980@gmail.com>  Mon, 06 May 2019 00:00:00 -0000

ros-one-imu-filter-madgwick (1.2.0-0jammy) jammy; urgency=high

  * Remove outdated Makefile
  * Add warning when IMU time stamp is zero
    Closes #82 <https://github.com/ccny-ros-pkg/imu_tools/issues/82>.
  * update to use non deprecated pluginlib macro (#77 <https://github.com/ccny-ros-pkg/imu_tools/issues/77>)
  * Contributors: Martin Günther, Mikael Arguedas

 -- Martin Günther <martin.guenther1980@gmail.com>  Fri, 25 May 2018 00:00:00 -0000

ros-one-imu-filter-madgwick (1.1.5-0jammy) jammy; urgency=high

  * Initial release into Lunar
  * Remove support for Vector3 mag messages
  * Change default world_frame = enu
  * Rewrite rosbags: Use MagneticField for magnetometer
  * Contributors: Martin Günther

 -- Martin Günther <martin.guenther1980@gmail.com>  Wed, 24 May 2017 00:00:00 -0000

ros-one-imu-filter-madgwick (1.1.4-0jammy) jammy; urgency=high

  * Print warning if waiting for topic
    Closes #61 <https://github.com/ccny-ros-pkg/imu_tools/issues/61>.
  * Fix boost::lock_error on shutdown
  * Contributors: Martin Günther

 -- Martin Günther <martin.guenther1980@gmail.com>  Mon, 22 May 2017 00:00:00 -0000

ros-one-imu-filter-madgwick (1.1.3-0jammy) jammy; urgency=high

  * Return precisely normalized quaternions
    Fixes #67 <https://github.com/ccny-ros-pkg/imu_tools/issues/67> : TF_DENORMALIZED_QUATERNION warning added in TF2 0.5.14.
  * Tests: Check that output quaternions are normalized
  * Fixed lock so it stays in scope until end of method.
  * Contributors: Jason Mercer, Martin Guenther, Martin Günther

 -- Martin Günther <martin.guenther1980@gmail.com>  Fri, 10 Mar 2017 00:00:00 -0000

ros-one-imu-filter-madgwick (1.1.2-0jammy) jammy; urgency=high

  * Add missing dependency on tf2_geometry_msgs
  * Contributors: Martin Guenther

 -- Martin Günther <martin.guenther1980@gmail.com>  Wed, 07 Sep 2016 00:00:00 -0000

ros-one-imu-filter-madgwick (1.1.1-0jammy) jammy; urgency=high

  * Add parameter "world_frame": optionally use ENU or NED instead of NWU
    convention (from #60 <https://github.com/ccny-ros-pkg/imu_tools/issues/60>;
    closes #36 <https://github.com/ccny-ros-pkg/imu_tools/issues/36>)
  * Add parameter "stateless" for debugging purposes: don't do any stateful
    filtering, but instead publish the orientation directly computed from the
    latest accelerometer (+ optionally magnetometer) readings alone
  * Replace the (buggy) Euler-angle-based initialization routine
    (ImuFilterRos::computeRPY) by a correct transformation
    matrix based one (StatelessOrientation::computeOrientation) and make it
    available as a library function
  * Refactor madgwickAHRSupdate() (pull out some functions, remove micro
    optimizations to improve readability)
  * Add unit tests


## ros-one-imu-filter-madgwick 1.2.6-4jammy.20251207.2144

=== debian/changelog ===
ros-one-imu-filter-madgwick (1.2.6-4jammy.20251207.2144) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Günther <martin.guenther1980@gmail.com>  Sun, 07 Dec 2025 21:44:36 +0000

## ros-one-imu-filter-madgwick 1.2.6-4noble.20251023.0858

=== debian/changelog ===
ros-one-imu-filter-madgwick (1.2.6-4noble.20251023.0858) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Günther <martin.guenther1980@gmail.com>  Thu, 23 Oct 2025 08:58:08 +0000

ros-one-imu-filter-madgwick (1.2.6-0noble) noble; urgency=high

  * Merge pull request #192 <https://github.com/CCNYRoboticsLab/imu_tools/issues/192> from enwaytech/av/remove_launchers
    Increase max stddev, add pose visualization, fix error messages
  * add timeout to lookupTransform
    Otherwise there are a lot of warnings of lookup would require extrapolation into the future
  * publish orientation as Pose to vis on rviz
  * show correct topics even if remapped
  * increase max covariance
  * Contributors: Adi Vardi, Martin Günther

 -- Martin Günther <martin.guenther1980@gmail.com>  Fri, 12 Jan 2024 00:00:00 -0000

ros-one-imu-filter-madgwick (1.2.5-0noble) noble; urgency=high

  * Added ability to reset IMU filters when ROS time jumps back. (#165 <https://github.com/CCNYRoboticsLab/imu_tools/issues/165>)
  * Contributors: Martin Pecka

 -- Martin Günther <martin.guenther1980@gmail.com>  Fri, 19 Aug 2022 00:00:00 -0000

ros-one-imu-filter-madgwick (1.2.4-0noble) noble; urgency=high

  * Reformat everything using clang-format
  * Fix package dependencies
  * Fix trailing whitespace
  * Fix typo
  * Add declination and yaw offset. (#121 <https://github.com/CCNYRoboticsLab/imu_tools/issues/121>)
    Fixes #120 <https://github.com/CCNYRoboticsLab/imu_tools/issues/120>.
  * Add license files
    The "COPYING" file incorrectly had the text of the LGPL, but the
    original Madgwick filter [1], [2] is GPL licensed. The source code
    headers correctly have the GPLv3 license text.
    [1]: https://x-io.co.uk/open-source-imu-and-ahrs-algorithms/
    [2]: https://github.com/xioTechnologies/Fusion
  * Contributors: Martin Günther, tgreier

 -- Martin Günther <martin.guenther1980@gmail.com>  Tue, 12 Apr 2022 00:00:00 -0000

ros-one-imu-filter-madgwick (1.2.3-0noble) noble; urgency=high

  * Fix "non standard content" warning in imu_tools metapackage
    Fixes #135 <https://github.com/ccny-ros-pkg/imu_tools/issues/135>.
  * Add example launch file for imu_filter_madgwick (#132 <https://github.com/ccny-ros-pkg/imu_tools/issues/132>)
  * Update maintainers in package.xml
  * Fix warnings: reordering and unused vars
  * Set cmake_policy CMP0048 to fix warning
  * Contributors: Martin Günther, pietrocolombo

 -- Martin Günther <martin.guenther1980@gmail.com>  Fri, 09 Apr 2021 00:00:00 -0000

ros-one-imu-filter-madgwick (1.2.2-0noble) noble; urgency=high

  * Drop the signals component of Boost (#103 <https://github.com/ccny-ros-pkg/imu_tools/issues/103>)
  * Add the option to remove the gravity vector (#101 <https://github.com/ccny-ros-pkg/imu_tools/issues/101>)
  * fix install path & boost linkage issues
  * Contributors: Alexis Paques, Martin Günther, Mike Purvis, Sean Yen

 -- Martin Günther <martin.guenther1980@gmail.com>  Mon, 25 May 2020 00:00:00 -0000

ros-one-imu-filter-madgwick (1.2.1-0noble) noble; urgency=high

  * Skip messages and warn if computeOrientation fails
  * Contributors: Martin Günther

 -- Martin Günther <martin.guenther1980@gmail.com>  Mon, 06 May 2019 00:00:00 -0000

ros-one-imu-filter-madgwick (1.2.0-0noble) noble; urgency=high

  * Remove outdated Makefile
  * Add warning when IMU time stamp is zero
    Closes #82 <https://github.com/ccny-ros-pkg/imu_tools/issues/82>.
  * update to use non deprecated pluginlib macro (#77 <https://github.com/ccny-ros-pkg/imu_tools/issues/77>)
  * Contributors: Martin Günther, Mikael Arguedas

 -- Martin Günther <martin.guenther1980@gmail.com>  Fri, 25 May 2018 00:00:00 -0000

ros-one-imu-filter-madgwick (1.1.5-0noble) noble; urgency=high

  * Initial release into Lunar
  * Remove support for Vector3 mag messages
  * Change default world_frame = enu
  * Rewrite rosbags: Use MagneticField for magnetometer
  * Contributors: Martin Günther

 -- Martin Günther <martin.guenther1980@gmail.com>  Wed, 24 May 2017 00:00:00 -0000

ros-one-imu-filter-madgwick (1.1.4-0noble) noble; urgency=high

  * Print warning if waiting for topic
    Closes #61 <https://github.com/ccny-ros-pkg/imu_tools/issues/61>.
  * Fix boost::lock_error on shutdown
  * Contributors: Martin Günther

 -- Martin Günther <martin.guenther1980@gmail.com>  Mon, 22 May 2017 00:00:00 -0000

ros-one-imu-filter-madgwick (1.1.3-0noble) noble; urgency=high

  * Return precisely normalized quaternions
    Fixes #67 <https://github.com/ccny-ros-pkg/imu_tools/issues/67> : TF_DENORMALIZED_QUATERNION warning added in TF2 0.5.14.
  * Tests: Check that output quaternions are normalized
  * Fixed lock so it stays in scope until end of method.
  * Contributors: Jason Mercer, Martin Guenther, Martin Günther

 -- Martin Günther <martin.guenther1980@gmail.com>  Fri, 10 Mar 2017 00:00:00 -0000

ros-one-imu-filter-madgwick (1.1.2-0noble) noble; urgency=high

  * Add missing dependency on tf2_geometry_msgs
  * Contributors: Martin Guenther

 -- Martin Günther <martin.guenther1980@gmail.com>  Wed, 07 Sep 2016 00:00:00 -0000

ros-one-imu-filter-madgwick (1.1.1-0noble) noble; urgency=high

  * Add parameter "world_frame": optionally use ENU or NED instead of NWU
    convention (from #60 <https://github.com/ccny-ros-pkg/imu_tools/issues/60>;
    closes #36 <https://github.com/ccny-ros-pkg/imu_tools/issues/36>)
  * Add parameter "stateless" for debugging purposes: don't do any stateful
    filtering, but instead publish the orientation directly computed from the
    latest accelerometer (+ optionally magnetometer) readings alone
  * Replace the (buggy) Euler-angle-based initialization routine
    (ImuFilterRos::computeRPY) by a correct transformation
    matrix based one (StatelessOrientation::computeOrientation) and make it
    available as a library function
  * Refactor madgwickAHRSupdate() (pull out some functions, remove micro
    optimizations to improve readability)
  * Add unit tests


=== debian/control ===
Source: ros-one-imu-filter-madgwick
Section: misc
Priority: optional
Maintainer: Martin Günther <martin.guenther1980@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-one-catkin, ros-one-dynamic-reconfigure, ros-one-geometry-msgs, ros-one-message-filters, ros-one-nodelet, ros-one-pluginlib, ros-one-roscpp, ros-one-sensor-msgs, ros-one-tf2, ros-one-tf2-geometry-msgs, ros-one-tf2-ros
Homepage: http://ros.org/wiki/imu_filter_madgwick
Standards-Version: 3.9.2

Package: ros-one-imu-filter-madgwick
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-one-dynamic-reconfigure, ros-one-geometry-msgs, ros-one-message-filters, ros-one-nodelet, ros-one-pluginlib, ros-one-roscpp, ros-one-sensor-msgs, ros-one-tf2, ros-one-tf2-geometry-msgs, ros-one-tf2-ros
Description: Filter which fuses angular velocities, accelerations, and (optionally) magnetic readings from a generic IMU device into an orientation.
 Based on code by Sebastian Madgwick, http://www.x-io.co.uk/node/8#open_source_ahrs_and_imu_algorithms.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-imu-filter-madgwick//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-imu-filter-madgwick 1.2.6-4noble.20251208.0844

=== debian/changelog ===
ros-one-imu-filter-madgwick (1.2.6-4noble.20251208.0844) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Günther <martin.guenther1980@gmail.com>  Mon, 08 Dec 2025 08:44:11 +0000

## ros-one-imu-filter-madgwick 1.2.7-2jammy.20260223.2135

=== debian/changelog ===
ros-one-imu-filter-madgwick (1.2.7-2jammy.20260223.2135) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Günther <martin.guenther1980@gmail.com>  Mon, 23 Feb 2026 21:35:02 +0000

ros-one-imu-filter-madgwick (1.2.7-0jammy) jammy; urgency=high



 -- Martin Günther <martin.guenther1980@gmail.com>  Tue, 29 Apr 2025 00:00:00 -0000

## ros-one-imu-filter-madgwick 1.2.7-2noble.20260223.2129

=== debian/changelog ===
ros-one-imu-filter-madgwick (1.2.7-2noble.20260223.2129) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Günther <martin.guenther1980@gmail.com>  Mon, 23 Feb 2026 21:29:10 +0000

ros-one-imu-filter-madgwick (1.2.7-0noble) noble; urgency=high



 -- Martin Günther <martin.guenther1980@gmail.com>  Tue, 29 Apr 2025 00:00:00 -0000
